GEOS 3.4.2

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
geos::operation::overlay::MaximalEdgeRing Class Reference

A ring of edges which may contain nodes of degree > 2. More...

`#include <MaximalEdgeRing.h>`

Inheritance diagram for geos::operation::overlay::MaximalEdgeRing:

## Public Member Functions
| MaximalEdgeRing (geomgraph::DirectedEdge *start, const geom::GeometryFactory *geometryFactory)
geomgraph::DirectedEdge * | getNext (geomgraph::DirectedEdge *de)
void | setEdgeRing (geomgraph::DirectedEdge *de, geomgraph::EdgeRing *er)
std::vector< MinimalEdgeRing * > * | buildMinimalRings ()
| This function returns a newly allocated vector of pointers to newly allocated MinimalEdgeRing objects.
void | buildMinimalRings (std::vector< MinimalEdgeRing * > &minEdgeRings)
| This function pushes pointers to newly allocated MinimalEdgeRing objects to the provided vector.
void | buildMinimalRings (std::vector< EdgeRing * > &minEdgeRings)
void | linkDirectedEdgesForMinimalEdgeRings ()
| For all nodes in this EdgeRing, link the DirectedEdges at the node to form minimalEdgeRings.
Public Member Functions inherited from geos::geomgraph::EdgeRing
| EdgeRing (DirectedEdge *newStart, const geom::GeometryFactory *newGeometryFactory)
bool | isIsolated ()
bool | isHole ()
geom::LinearRing * | getLinearRing ()
Label & | getLabel ()
bool | isShell ()
EdgeRing * | getShell ()
void | setShell (EdgeRing *newShell)
void | addHole (EdgeRing *edgeRing)
geom::Polygon * | toPolygon (const geom::GeometryFactory *geometryFactory)
void | computeRing ()
std::vector< DirectedEdge * > & | getEdges ()
int | getMaxNodeDegree ()
void | setInResult ()
bool | containsPoint (const geom::Coordinate &p)
void | testInvariant ()

## Additional Inherited Members
Protected Member Functions inherited from geos::geomgraph::EdgeRing
void | computePoints (DirectedEdge *newStart)
| throw(const TopologyException &)
void | mergeLabel (const Label &deLabel)
void | mergeLabel (const Label &deLabel, int geomIndex)
| Merge the RHS label from a DirectedEdge into the label for this EdgeRing.
void | addPoints (Edge *edge, bool isForward, bool isFirstEdge)
Protected Attributes inherited from geos::geomgraph::EdgeRing
DirectedEdge * | startDe
const geom::GeometryFactory * | geometryFactory
std::vector< EdgeRing * > | holes
| a list of EdgeRings which are holes in this EdgeRing

## Detailed Description

A ring of edges which may contain nodes of degree > 2.

A MaximalEdgeRing may represent two different spatial entities:

- a single polygon possibly containing inversions (if the ring is oriented CW)
- a single hole possibly containing exversions (if the ring is oriented CCW)

If the MaximalEdgeRing represents a polygon, the interior of the polygon is strongly connected.

These are the form of rings used to define polygons under some spatial data models. However, under the OGC SFS model, MinimalEdgeRings are required. A MaximalEdgeRing can be converted to a list of MinimalEdgeRings using the buildMinimalRings() method.

See Also
  com.vividsolutions.jts.operation.overlay.MinimalEdgeRing

## Member Function Documentation

std::vector<MinimalEdgeRing*>* geos::operation::overlay::MaximalEdgeRing::buildMinimalRings | ( |  | ) |

This function returns a newly allocated vector of pointers to newly allocated MinimalEdgeRing objects.

Deprecated:
  pass the vector yourself instead

The documentation for this class was generated from the following file:

- MaximalEdgeRing.h